namespace CMSMicroservice.Application.UserOrderCQ.Commands.CreateNewUserOrder;
public class CreateNewUserOrderCommandValidator : AbstractValidator<CreateNewUserOrderCommand>
{
    public CreateNewUserOrderCommandValidator()
    {
        RuleFor(model => model.Amount)
            .NotNull();
        RuleFor(model => model.PackageId)
            .NotNull();
        RuleFor(model => model.PaymentStatus)
            .IsInEnum()
            .NotNull();
        RuleFor(model => model.UserId)
            .NotNull();
        RuleFor(model => model.UserAddressId)
            .NotNull();
        RuleFor(model => model.PaymentMethod)
            .IsInEnum();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewUserOrderCommand>.CreateWithOptions((CreateNewUserOrderCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
